{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends "flux/detail.html.twig" %}
{% import ":_includes:macros.html.twig" as appMacros %}

{% form_theme form _self %}

{% block _expert_editor_query_row %}
  <div class="form-group{% if (not compound or force_error|default(false)) and not valid %} has-error{% endif %}">
    <div class="col-sm-12">
      <div class="sparql-editor">
        {{- form_widget(form) -}}
        <a href="" data-toggle="modal-remote" class="btn btn-sm btn-preview btn-default">
          <span class="fa fa-play"></span>&nbsp;{{ "btn.preview_results" | trans }}
        </a>
      </div>
      {{- form_errors(form) -}}
    </div>
    {##}</div>
{% endblock %}

{% block _expert_editor_query_errors -%}
  {% if errors|length > 0 -%}
    <div class="bootstrap-notify-alert" data-type="error">
      <ul class="list-unstyled">
        {%- for error in errors -%}
          <li>{{ error.message }}</li>
        {%- endfor -%}
      </ul>
    </div>
  {%- endif %}
{%- endblock %}

{% block subcontent %}
  {{ form_start(form, {'attr': {'novalidate': 'novalidate'}}) }}

  <div class="box-body p-0">
    {{ form_row(form.query) }}
  </div>

  {% if is_granted('flux.edit', flux) %}
    <div class="box-footer">
        {{ appMacros.partialDownloadBtn(flux) }}
        <button type="submit" class="btn btn-primary">{{ "btn.save" | trans }}</button>
    </div>
  {% endif %}
  {{ form_end(form) }}
{% endblock %}

{% block javascripts %}
  <script type="text/javascript">
    $(function() {
      var promise = $("#expert_editor_query").data('promise');
      $.when( promise ).then(function( editor ) {
          // check query validity
          function checkValidity() {
              var valid = editor.getValue() && editor.queryValid;
              $(".btn-preview")[valid ? "removeClass" : "addClass"]("disabled");
              $("button[type=submit]").attr('disabled', !valid);
              $(".form-group:has(.sparql-editor)")[valid ? "removeClass" : "addClass"]("has-error");
          }
          editor.on('change', checkValidity);
          checkValidity();

          // open preview on click
          $(".btn-preview").click(function() {
              var query = editor.getValue();
              $(this).attr('href', "{{ path('flux.editor.preview', {id: flux.id}) }}?query=" + encodeURIComponent(query));
          });
      });
    });
  </script>
{% endblock %}
